//  GetPass 3.0 - C_FILTER for F6FBB BBS Software

//  Written by Marco Savegnago IW3FQG

#ifndef __MFAPPS_H
#define __MFAPPS_H

#include <dir.h>
#include <new.h>

class    MessageFile;

class ResInfApp
{

public:

	ResInfApp( int, char * * );

	~ResInfApp();

	run();

protected:
	static void new_failure();

	enum  TOption
	{
        INF_FILE,
		PASSWORD_FILE,
        REGISTERED_LIMIT,
        UNREGISTERED_LIMIT,
        MAX_OPTIONS
	};

private:

	char  	curr_drive[ MAXDRIVE ];
	char  	curr_dir  [ MAXDIR ];
	char  	curr_name [ MAXFILE ];
	char 	fconfig [ MAXPATH ];
};

inline ResInfApp::~ResInfApp()
{
	set_new_handler( NULL );
}

#define uchar unsigned char

typedef struct {        /* Callsign structure used in info  */

  char callsign[7]   ;
  char ssid          ;

} indicat            ;

typedef struct {

  indicat  indic     ;  /* 8   Callsign                     */
  indicat  relai[8]  ;  /* 64  Digis path                   */
  long     lastmes   ;  /* 4   Last L number                */
  long     nbcon     ;  /* 4   Number of connexions         */
  long     hcon      ;  /* 4   Last connexion date          */
  long     lastyap   ;  /* 4   Last YN date                 */
  unsigned flags     ;  /* 2   Flags                        */
  unsigned on_base   ;  /* 2   ON Base number               */
  uchar    nbl       ;  /* 1   Lines paging                 */
  uchar    lang      ;  /* 1   Language                     */
  char     free[4]   ;  /* 1   Res                          */
  int      kb;
  char     free1[21]  ;  /* 27  Reserved                     */
  char     nom[18]   ;  /* 18  1st Name                     */
  char     prenom[13];  /* 13  Christian name               */
  char     adres[61] ;  /* 61  Address                      */
  char     ville[31] ;  /* 31  City                         */
  char     teld[13]  ;  /* 13  home phone                   */
  char     telp[13]  ;  /* 13  job phone                    */
  char     home[41]  ;  /* 41  home BBS                     */
  char     qra[7]    ;  /* 7   Qth Locator                  */
  char     priv[13]  ;  /* 13  PRIV directory               */
  char     filtre[7] ;  /* 7   LC choice filter             */
  char     pass[13]  ;  /* 13  Password                     */
  char     zip[9]    ;  /* 9   Zipcode                      */

} info               ;  /* 360 bytes = lenght of one record */



/*
 A null type of message (00 hex) invalidates the record.

 Dates are given as the number of seconds since january 1st, 1970 00:00.

 Masks are bit fields, number of bit corresponds to the number of the BBS in
the BBS.SYS file.

In C language, all strings are ended with a NULL (00 hex) character.
*/

#endif // __MFAPPS_H

